﻿using System.Windows;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WpfDesktopEdition;
using System.Collections.ObjectModel;
using System.Drawing;
using System.Linq;

namespace Post9837_WPFOverlayDrawWithGeoCanvasParameter
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Map1_Loaded(object sender, RoutedEventArgs e)
        {
            Map1.MapUnit = GeographyUnit.DecimalDegree;

            ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(@"..\..\App_Data\Countries02.shp");
            //worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.FromArgb(100, GeoColor.SimpleColors.Green));
            //worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            worldLayer.Open();
            Map1.CurrentExtent = worldLayer.GetBoundingBox();

            //cImageServerLayer ocImageServerLayer = new cImageServerLayer();
            ocCustomLayer = new cCustomLayer();
            ocCustomLayer.ServerCache = false;

            LayerOverlay worldOverlay = new LayerOverlay();
            worldOverlay.TileType = TileType.SingleTile;
            worldOverlay.TileCache = new FileBitmapTileCache(@"..\..\App_Data\layerOverlayDrawWithCache\\", "ManualCache");
            //worldOverlay.Layers.Add("WorldLayer", worldLayer);
            //worldOverlay.Layers.Add("ImageServerLayer", ocImageServerLayer);
            worldOverlay.Layers.Add("ImageServerLayer", ocCustomLayer);
            Map1.Overlays.Add("WorldOverlay", worldOverlay);

            Map1.Refresh();
        }

        private cCustomLayer ocCustomLayer;

        //private void DrawWithoutCache_Click(object sender, RoutedEventArgs e)
        //{
        //    LayerOverlay layerOverlay = Map1.Overlays.OfType<LayerOverlay>().First();
        //    Bitmap nativeImage = new Bitmap((int)Map1.ActualWidth, (int)Map1.ActualHeight);
        //    GdiPlusGeoCanvas geoCanvas = new GdiPlusGeoCanvas();
        //    geoCanvas.BeginDrawing(nativeImage, Map1.CurrentExtent, Map1.MapUnit);
        //    layerOverlay.Draw(geoCanvas);
        //    geoCanvas.EndDrawing();

        //    nativeImage.Save(@"..\..\App_Data\layerOverlayDrawWithoutCache.png");
        //}

        //private void DrawWithCache_Click(object sender, RoutedEventArgs e)
        //{
        //    LayerOverlay layerOverlay = Map1.Overlays.OfType<LayerOverlay>().First();
        //    layerOverlay.TileCache = new FileBitmapTileCache(@"..\..\App_Data\layerOverlayDrawWithCache\\", "ManualCache");
        //    Bitmap nativeImage = new Bitmap((int)Map1.ActualWidth, (int)Map1.ActualHeight);
        //    GdiPlusGeoCanvas geoCanvas = new GdiPlusGeoCanvas();
        //    geoCanvas.BeginDrawing(nativeImage, Map1.CurrentExtent, Map1.MapUnit);
        //    layerOverlay.Draw(geoCanvas);
        //    geoCanvas.EndDrawing();
        //    layerOverlay.TileCache = null;
        //}
    }

    //public static class LayerOverlayExtension
    //{
    //    public static void Draw(this LayerOverlay layerOverlay, GeoCanvas geoCanvas)
    //    {
    //        Collection<SimpleCandidate> labelCandidates = new Collection<SimpleCandidate>();
    //        foreach (var layer in layerOverlay.Layers)
    //        {
    //            lock (layer)
    //            {
    //                if (!layer.IsOpen) layer.Open();
    //                geoCanvas.Flush();
    //                layer.Draw(geoCanvas, labelCandidates);
    //            }
    //        }

    //        if (layerOverlay.TileCache != null)
    //        {
    //            layerOverlay.TileCache.TileMatrix.Scale = ExtentHelper.GetScale(geoCanvas.CurrentWorldExtent, geoCanvas.Width, geoCanvas.MapUnit);
    //            var tiles = layerOverlay.TileCache.GetTiles(geoCanvas.CurrentWorldExtent);
    //            foreach (var tile in tiles)
    //            {
    //                if (tile.Bitmap == null)
    //                {
    //                    GdiPlusGeoCanvas tempGeoCanvas = new GdiPlusGeoCanvas();
    //                    Bitmap nativeImage = new Bitmap(layerOverlay.TileWidth, layerOverlay.TileHeight);
    //                    try
    //                    {
    //                        tempGeoCanvas.BeginDrawing(nativeImage, tile.BoundingBox, geoCanvas.MapUnit);
    //                        Collection<SimpleCandidate> tempLabelCandidates = new Collection<SimpleCandidate>();
    //                        foreach (var layer in layerOverlay.Layers)
    //                        {
    //                            lock (layer)
    //                            {
    //                                if (!layer.IsOpen) layer.Open();
    //                                geoCanvas.Flush();
    //                                layer.Draw(tempGeoCanvas, tempLabelCandidates);
    //                            }
    //                        }
    //                        tempGeoCanvas.EndDrawing();
    //                        tile.Bitmap = nativeImage;
    //                        layerOverlay.TileCache.SaveTile(tile);
    //                    }
    //                    finally
    //                    {
    //                        nativeImage.Dispose();
    //                    }
    //                }
    //            }

    //        }
    //    }
    //}
}
