﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WpfDesktopEdition;
using System.Drawing;
using System.Collections.ObjectModel;

namespace Post9837_WPFOverlayDrawWithGeoCanvasParameter
{
    class cGeoServer
    {

        public byte[] getImage(string BoundingBox, int width, int height, GeographyUnit mapUnit)
        {

            ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(@"..\..\App_Data\Countries02.shp");
            worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.FromArgb(100, GeoColor.SimpleColors.Blue));
            worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            worldLayer.Open();

            BitmapTileCache oTileCache = new FileBitmapTileCache(@"..\..\App_Data\layerOverlayDrawWithCache\\", "ManualCache");
            GdiPlusGeoCanvas geoCanvas = new GdiPlusGeoCanvas();
            RectangleShape WordExtent = new RectangleShape(BoundingBox);
            Bitmap MapImage = new Bitmap(width, height);
            Graphics mapImageContext = Graphics.FromImage(MapImage);
            System.IO.MemoryStream ImageStream = new System.IO.MemoryStream();
            double resolution = Math.Max(WordExtent.Width / width, WordExtent.Height / height);

            oTileCache.TileMatrix.Scale = ExtentHelper.GetScale(WordExtent, width, mapUnit);
            var tiles = oTileCache.GetTiles(WordExtent);
            foreach (var tile in tiles)
            {

                Bitmap nativeImage = new Bitmap(oTileCache.TileMatrix.TileWidth, oTileCache.TileMatrix.TileHeight);

                try
                {
                    if (tile.Bitmap == null)
                    {
                        GdiPlusGeoCanvas tempGeoCanvas = new GdiPlusGeoCanvas();
                        tempGeoCanvas.BeginDrawing(nativeImage, tile.BoundingBox, mapUnit);
                        Collection<SimpleCandidate> tempLabelCandidates = new Collection<SimpleCandidate>();

                        lock (worldLayer)
                        {
                            if (!worldLayer.IsOpen) worldLayer.Open();
                            tempGeoCanvas.Flush();
                            worldLayer.Draw(tempGeoCanvas, tempLabelCandidates);
                        }
                        tempGeoCanvas.EndDrawing();
                        tile.Bitmap = nativeImage;
                        oTileCache.SaveTile(tile);
                    }
                    else
                    {
                        nativeImage = tile.Bitmap;
                    }

                    double offsetX = (tile.BoundingBox.UpperLeftPoint.X - WordExtent.UpperLeftPoint.X) / resolution;
                    double offsetY = (WordExtent.UpperLeftPoint.Y - tile.BoundingBox.UpperLeftPoint.Y) / resolution;
                    mapImageContext.DrawImageUnscaled(nativeImage, (int)offsetX, (int)offsetY);
                }
                finally
                {
                    nativeImage.Dispose();
                }
            }

            MapImage.Save(ImageStream, System.Drawing.Imaging.ImageFormat.Png);
            return ImageStream.ToArray();
            
        }
    }
}
